#include <MK64F12.H>

void GPIO_init(void){
	
	SIM_SCGC5 |= SIM_SCGC5_PORTB_MASK; 		//Enable Port B Clock Gate Control
	SIM_SCGC5 |= SIM_SCGC5_PORTC_MASK;		//Enable Port C Clock Gate Control
	SIM_SCGC5 |= SIM_SCGC5_PORTE_MASK;		//Enable Port E Clock Gate Control

	/*Port Multipexing*/
	PORTB_PCR21 |= 1UL<<8;         //Blue Led configured as Alt 1
	PORTB_PCR22 |= 1UL<<8;				 //Red Led configured as Alt 1
	PORTE_PCR26 |= 1UL<<8;		     //Green Led configured as Alt 1
	PORTC_PCR6  |= 1UL<<8;		     //Switch 2 configured as Alt 1
	
	GPIOB_PDDR |=  (1UL << 21);		 //Set bit 21 of port B as Output
	GPIOB_PDDR |=  (1UL << 22);		 //Set bit 22 of port B as Output
	GPIOE_PDDR |=  (1UL << 26);		 //Set bit 26 of port E as Output
	GPIOC_PDDR &=~ (1UL << 6);		 //Set bit 6 of port C as Input
	
}

int main(void){
	uint32_t Delay = 0xFFFFF;		//Delay for blink delay
	GPIO_init();                //Intialise the pins for GPIO
	
	GPIOB_PDOR |= (1UL << 22);	//Turn Off Red LED
	GPIOB_PDOR |= (1UL << 21);	//Turn Off Blue LED
	GPIOE_PDOR |= (1UL << 26);	//Turn Off Green LED

	while(1)
	{
		if(!(GPIOC_PDIR & (1UL<< 6)))		//Blink LEDs when switch is pressed
		{
			GPIOB_PDOR |= (1UL << 22);	//Turn Off Red LED
			GPIOB_PDOR |= (1UL << 21);	//Turn Off Blue LED
			GPIOE_PDOR |= (1UL << 26);	//Turn Off Green LED
			
			Delay = 0xFFFFF;						//Reset Delay
			GPIOB_PDOR &=~ (1UL << 22);	//Turn On Red LED
			while(Delay != 0)		      	//Wait Delay Value
			{
				Delay--;
			}
			Delay = 0xFFFFF;						//Reset Delay
			GPIOB_PDOR |= (1UL << 22) ; //Turn Off Red LED
			while(Delay != 0)		        //Wait Delay Value
			{
				Delay--;
			}
			Delay = 0xFFFFF;		        //Reset Delay
			GPIOE_PCOR |= (1UL << 26);	//Turn On Green LED
			while(Delay != 0)		        //Wait Delay Value
			{
				Delay--;
			}
			Delay = 0xFFFFF;						//Reset Delay
			GPIOE_PSOR |= (1UL << 26);  //Turn Off Green LED
			while(Delay != 0)		        //Wait Delay Value
			{
				Delay--;
			}
			Delay = 0xFFFFF;						//Reset Delay
			GPIOB_PTOR |= (1UL << 21);	//Turn On Blue LED
			while(Delay != 0)						//Wait Delay Value
			{
				Delay--;
			}
			Delay = 0xFFFFF;						//Reset Delay
			GPIOB_PTOR |=  (1UL << 21); //Turn Off Blue LED
			while(Delay != 0)		 				//Wait Delay Value
			{
				Delay--;
			}
			
		}
	else {
			GPIOB_PDOR &=~ (1UL << 22);	//Turn On Red LED
			GPIOB_PDOR &=~ (1UL << 21);	//Turn On Blue LED
		}
	}
	return 0;
}